<template>
  <div>
    <Modal v-model="showEditModal" v-drag :mask-closable="false">
      <p slot="header">
        {{ modalTitle }}
      </p>
      <div>
        <Form id="edit-form" ref="formObj" :model="formObj" :rules="ruleValidate" :label-width="80">
          <Form-item label="人员名称" prop="staffId">
            <el-select
              v-model="formObj.staffId"
              placeholder="请选择员工"
              filterable
              clearable
              size="small"
              style="width:99% "
            >
              <el-option v-for="item in staffList" :key="item.id" :value="item.id" :label="item.name" />
            </el-select>
          </Form-item>
          <Form-item label="任务名称" prop="name">
            <Input v-model="formObj.name" name="name" placeholder="请输入任务名称" ></Input>
          </Form-item>
          <Form-item label="任务日期" prop="taskDate">
            <Date-picker
              v-model="formObj.taskDate"
              name="taskDate"
              type="date"
              placeholder="任务日期"
              format="yyyy-MM-dd"
              style="width: 100%;"
            />
          </Form-item>
          <Form-item label="内容描述" prop="remark">
            <Input v-model="formObj.remark" name="remark" placeholder="请输入内容描述" /></Input>
          </Form-item>
        </Form>
      </div>
      <div slot="footer">
        <modal-footer ref="footerModal" :footer="footerList" @on-result-change="_footerResult" />
      </div>
    </Modal>
  </div>
</template>
<script>
/**
 * 添加编辑
 */
import { staffTask, staffInfo } from '../../../api'

export default {
  data() {
    return {
      id: '',
      modalTitle: '添加',
      formObj: {
        staffId: '',
        name: '',
        taskDate: '',
        remark: ''
      },
      staffList: [],
      ruleValidate: {
        name: [{ required: true, message: '任务名称不能为空', trigger: 'blur' }]
      },
      showEditModal: false,
      footerList: [
        { id: '', name: '取消', type: '' },
        { id: '', name: '保存', type: 'primary' }
      ]
    }
  },
  methods: {
    // modal
    _footerResult(name) {
      switch (name) {
        case '取消':
          this._cancel()
          break
        case '保存':
          this._ok()
          break
      }
    },
    _hideLoading() {
      this.$refs.footerModal._hideLoading()
    },
    _resultChange(result, msg) {
      if (result) {
        this.showEditModal = false
        this.$Message.success(msg)
        this.$emit('on-result-change')
      }
      this._hideLoading()
    },
    _ok() {
      this.$refs.formObj.validate(valid => {
        if (valid) {
          this._save(this.formObj)
        } else {
          this.$Message.error('表单验证失败')
          this._hideLoading()
        }
      })
    },
    _getStaffList: async function() {
      const result = await staffInfo.list({ status: 1 })
      if (result) {
        this.staffList = result
      }
    },
    // 添加、编辑保存
    _save: async function(data) {
      // 添加
      if (this.$string(this.id).isEmpty()) {
        const result = await staffTask.add(data)
        this._resultChange(result, '添加成功')
      } else {
        // 编辑
        const result = await staffTask.edit({
          id: this.formObj.id,
          obj: data
        })
        this._resultChange(result, '编辑成功')
      }
    },
    _cancel() {
      this.showEditModal = false
    },
    _open(formObj) {
      this.$refs.formObj.resetFields()
      this.showEditModal = true
      this._hideLoading()
      this._getStaffList()
      if (this.$string(formObj).isEmpty()) {
        this.id = ''
        this.modalTitle = '添加人员任务'
      } else {
        this.id = formObj.id
        this.formObj = formObj
        this.modalTitle = '编辑人员任务'
        if (undefined !== formObj.taskDate) {
          this.formObj.taskDate = this.$dateformat(
            new Date(formObj.taskDate),
            'yyyy-mm-dd'
          )
        } else {
          this.formObj.taskDate = ''
        }
      }
    }
  }
}
</script>
